#!/usr/bin/php -q
<?php
/*******************************************************************************
Exemple of the use of the snmp_networkclass
  $yourobject=new networkclass;
  $yourobject->Init($sess);   or  $yourobject->Init($sess,$path_to_snmp_binary);  or   $yourobject->Init($sess,$path_to_snmp_binary,$other_get_filename,$other_getnext_filename,$other_walk_filename,$other_set_filename,$snmpbinversion);
  $yourobject->LoadClass("networkclass"); // needed if you want to use other functions than get,set,getnext,walk
  ....
  put the function you want to use
  ....
  $yourobject->close();
  
  You can use some functions relative to the class
  example like $yourobject->priv("Duplex");
  // where FunctionName are "Duplex","Trunk","Channel","LACP","PaGP","VLAN"
  //  ... , "CPU","Temperature","DeviceIsHost","Checktypdevice"
  //  ... , "MAC", "STPchanges","Fan","RAM","STPchanges"
  //  ... , "tftp" (this last is coupled with $yourobject->InitTftp...)
  $yourobject->priv($FunctionName);
  
  You can use some MIB functions // "sysUpTime", "sysContact", "sysName", "interfaces.ifTable.ifIndex" and all the mib under iso.org.dod.internet.mgmt.system
  example $yourobject->give("sysDescr");

  For each function the value returned are :
  $yourobject->retcode
  $yourobject->result
  $yourobject->errormsg

  You can active the Debugging (default are $isdebug=false,$islog=false,$debugfile="DEBUG.txt"
  $yourobject->setdebug($isdebug=false,$islog=false,$debugfile="");
  
  You can also overwrite the debug function "networkclass_debug" like this (example for CACTI project) in your file but before the include of the networkclass
  function networkclass_debug($message) {
    global $networkclass_isdebug,$networkclass_islog,$networkclass_debugfile;
    if ($networkclass_isdebug) print($message);
    if ($networkclass_islog) debug_log_insert(....);
  }

  You can also use the SNMP funtions directly if you want  (NORMALLY not NEEDED)
  $yourobject->get($oidOrMIB);
  $yourobject->getnext($oidOrMIB);
  $yourobject->setsnmpcommunity($yourcommunityWritestring);
  $yourobject->set($oidOrMIB,$thetypeOftheMIB,$theValueOftheMIB);
  $yourobject->walk($oidOrMIB);
  
  You can also change the initalisation's values during the session (before $yourobject->close();  !!!)
  $yourobject->snmpmethod($method,"your SNMP folder");   or $yourobject->snmpmethod($method,"your SNMP folder"); $yourobject->snmpmethod($method,"your SNMP folder",$other_get_filename,$other_getnext_filename,$other_walk_filename,$other_set_filename,$snmpbinversion);
  $yourobject->snmphostname($hostname);
  $yourobject->snmpversion($newversion);
  $yourobject->setsnmpcommunity($community);
  $yourobject->snmptimeout($timeout);
  $yourobject->snmpport($port);
  $yourobject->snmpuserpassword($user,$password,$auth_proto,$priv_pass,$priv_proto);
  $yourobject->snmpretries($retries);
  
  You can also see the initalisation's values
  $yourobject->snmphostname("");
  $yourobject->snmpversion("");
  $yourobject->setsnmpcommunity("");
  $yourobject->setsnmp3context("yourcontext");
  $yourobject->getsnmp3context();
  $yourobject->snmptimeout("");
  $yourobject->snmpport("");
  $yourobject->snmpuserpassword("","","MD5","","none");
  $yourobject->snmpretries("");

  Some other functions
  $yourobject->check();                   // not really needed
  
*******************************************************************************/

/* ---------------------------------------------------------------------- */
//  VARIABLES TO changes and have for your plugins
/* ---------------------------------------------------------------------- */
$sharednetworkclasspath= "."; // path_to_the_sharednetworkclass
/* ---------------------------------------------------------------------- */
include($sharednetworkclasspath."/snmp_networkclass.php");

/* ---------------------------------------------------------------------- */
/* BEGIN of the EXAMPLE */
/* ---------------------------------------------------------------------- */

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

readparameters($params);
someExamplesToExecute($params);

exit;

function someExamplesToExecute(&$param) {  
  /* initialize the value of my device to test */
  $host = $param["host"];
  $community=$param["community"];     // your community string or "" for default="public"
  $version = $param["version"];     // your snmp version "1" or "2" or "2c" or "3" or "" for default="1"
  $user = $param["user"];              // your snmp user for version 3
  $password =$param["password"];           // your snmp password for version 3
  $auth_proto= $param["auth_proto"];   // MD5 or SHA (SNMPv3 Authorization Protocol)
  $priv_pass= $param["priv_pass"];     // (SNMPv3 Privacy Passphrase)
  $priv_proto= $param["priv_proto"];  // none or DES or AES (SNMPv3 Privacy Protocol)
  $port = $param["port"];              // your snmp port or "" for default="161"
  $timeout = $param["timeout"];          // your snmp timeout in milliseconds or "" for default="500"
  $method=$param["method"]; // SNMP_METHOD_PHP (for pure PHP) or SNMP_METHOD_BINARY (for NET_SNMP or something else) // this name are for compatibility with cacti
                           // for CACTI $method= snmp_get_method($version);
  // for CACTI user here commented
  // $retries = read_config_option("snmp_retries");
  // if ($retries == "") $retries = 3;
  $retries = $param["retries"];
  
  if ($host=="") {
   print "ERROR: Invalid Parameter " . $parameter . "\n\n";
   display_help();
   exit;
  } 
  $sess = array($host,$version,$community,$user,$password,$auth_proto,$priv_pass,$priv_proto,$port,$timeout,$retries,$method);
  
  /* initalise the object */
  $obdevice=new networkclass;
  $obdevice->Init($sess);
  if ($obdevice->ini)
    print "initialisation:".(($obdevice->ini)?"OK":"not OK")."\n";
  else print "initialisation error:".(($obdevice->retcode)?"yes":"no"." error message ->".$obdevice->errormsg)."\n";
  print "\n";
  // You can also set the path to the binary or change the default NET_SNMP filenames with
  // $obdevice->Init($sess,$path_to_snmp_binary,$other_get_filename,$other_getnext_filename,$other_walk_filename,$other_set_filename,$snmpbinversion);
  // default NET_SNMPNAME are "snmpget", "snmpgetnext", "snmpwalk", "snmpset" (in windows with .exe at the end
  // for that reason you normally need only to give the NET_SNMP path if you want to use the binaries
  // you can also give the type of binaries $snmpbinversion<-SNMP_METHOD_NET or SNMP_METHOD_UCD default is SNMP_METHOD_NET
  // in CACTI you can set with $snmpbinversion=read_config_option("snmp_version")
  if ($method==SNMP_METHOD_BINARY)
     $obdevice->snmpmethod($method,$param["pathnetsnmp"]); //,"","","","","");

  $obdevice->LoadClass("networkclass"); // needed if you want to use other functions than get,set,getnext,walk
  
//  $obdevice->setdebug(true,true);
  print "show the sysDescr\n";
  $obdevice->give("sysDescr");
  if ($obdevice->retcode) print "sysDescr-> result=".$obdevice->result." \n";
  else print "sysDescr-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  print "\n";
  print "show the sysObjectID\n";
  $obdevice->give("sysObjectID");
  if ($obdevice->retcode) print "GIVE(sysObjectID)-> result=".print_r($obdevice->result,true)." \n";
  else print "GIVE(sysObjectID)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  print "\n";
  print "discover vendor\n";
  $obdevice->setvendor();
  if ($obdevice->retcode) print "GIVE Vendor-> result=".$obdevice->result." \n";
  else print "GIVE Vendor-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  
  $obdevice->close();
}

function snmp_debug($message,$isdebug,$islog) {
	if ($isdebug) print("DEBUG: " . $message . "\n");
	if ($islog) {
//		cacti_log($message, false, "SNMP-DOWNLOAD");
	}
}

function readparameters(&$param) {
	/* process calling arguments */
	$parms = $_SERVER["argv"];
	array_shift($parms);
	$valuesnmpversion="1";
	$hostname="";
	$valueuser="";$valuepassword="";
	$valuecommunity="public";
	$port="";
	$timeout=500;
	$valuepassword="";
	$retries=3;
	$auth_proto= "MD5";
	$priv_pass= "";
	$priv_proto= "none";
	$method=SNMP_METHOD_PHP;
	$pathToNetSnmp= "D:/Programme/NET-SNMP/usr/bin";
	foreach($parms as $parameter) {
		@list($arg, $value) = @explode("=", $parameter);
		switch ($arg) {
		case "--help":
			display_help();
			exit;
		case "-h":
			display_help();
			exit;
		case "-v":
		case "--version":
			$valuesnmpversion=$value;
			break;
		case "-c":
		case "--community":
			$valuecommunity=$value;
			break;
		case "-i":
		case "--ip":
			$hostname=$value;
			break;
		case "-u":
		case "--user":
			$valueuser=$value;
			break;
		case "-w":
		case "--password":
			$valuepassword=$value;
			break;
		case "--authproto":
			$auth_proto=$value;
			break;
		case "--privpass":
			$priv_pass=$value;
			break;
		case "--privproto":
			$priv_proto=$value;
			break;
		case "-p":
		case "--port":
			$port=$value;
			break;
		case "-t":
		case "--timeout":
			$timeout=intval($value);
			break;
		case "-r":
		case "--retries":
			$retries=intval($value);
			break;
		case "-m":
		case "--method":
			if (is_int(intval($value))) $method=intval($value);
			else if ($value=="SNMP_METHOD_BINARY") $method=SNMP_METHOD_BINARY;
			break;
		case "-a":
		case "--path":
			$pathToNetSnmp=$value;
			break;
		default:
			print "ERROR: Invalid Parameter " . $parameter . "\n\n";
			display_help();
			exit;
		}
	}
	$param = array("host"=>$hostname
		,"version" =>$valuesnmpversion
		,"community" =>$valuecommunity
		,"user" =>$valueuser
		,"password" =>$valuepassword
		,"auth_proto" => $auth_proto
		,"priv_pass" => $priv_pass
		,"priv_proto" => $priv_proto
		,"port" =>$port
		,"timeout" =>$timeout
		,"retries"=>$retries
		,"method" =>$method
		,"pathnetsnmp" =>$pathToNetSnmp);
}

/*	display_help - displays the usage of the function */
function display_help () {
	print "Examples for networkclass.php \n";
	print "usage: example_snmp_networkclassX.php [ | [-h | --help] | [-i | --ip=hostipaddress] | [-v | --version=version]"
		." | [-c | --community=snmpcommunity] | [-u | --user=username] | [-w | --password=password]"
		." | [-p | --port=port] | [-t | --timeout=timeout] | [-m | --method=valuemethod] | [-a | --path=pathToNET-SNMP]\n\n";
	print "-i or --ip=host ip address\n";
	print "-v or --version = snmp version\n";
	print "-c or --community=snmpcommunity\n";
	print "-u or --user = snmp username\n";
	print "-w or --password = snmp password\n";
	print "-p or --port = snmp port\n";
	print "-t or --timeout = snmp timeout\n";
	print "-r or --retries = snmp retries\n";
	print "-m or --method = snmp method (SNMP_METHOD_PHP or 1,  SNMP_METHOD_BINARY or 2 for binaries like NET-SNMP\n";
	print "-a or --path = path to NET-SNMP or UCD\n";
	print "-h or --help = display this help message\n";
	print "--authproto  = SNMPv3. MD5 or SHA (SNMPv3 Authorization Protocol, default MD5)\n";
	print "--privpass   = SNMPv3. Privacy Passphrase.\n";
	print "--privproto  = SNMPv3. none or DES or AES (SNMPv3 Privacy Protocol, default none)\n";
}

?>